<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="商品名" prop="name">
        <el-input v-model="formData.name" placeholder="请输入商品名" />
      </el-form-item>
      <el-form-item label="url" prop="url">
        <el-input v-model="formData.url" placeholder="请输入url" />
      </el-form-item>
      <el-form-item label="兑换积分" prop="point">
        <el-input v-model="formData.point" placeholder="请输入兑换积分" />
      </el-form-item>
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="联系人姓名" prop="contactName">
        <el-input v-model="formData.contactName" placeholder="请输入联系人姓名" />
      </el-form-item>
      <el-form-item label="联系地址" prop="contactAddress">
        <el-input v-model="formData.contactAddress" placeholder="请输入联系地址" />
      </el-form-item>
      <el-form-item label="联系电话" prop="contactPhone">
        <el-input v-model="formData.contactPhone" placeholder="请输入联系电话" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { RedeemApi, RedeemVO } from '@/api/menduner/system/redeem'

/** 兑换 表单 */
defineOptions({ name: 'RedeemForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  url: undefined,
  point: undefined,
  userId: undefined,
  contactName: undefined,
  contactAddress: undefined,
  contactPhone: undefined,
  status: undefined,
  remark: undefined
})
const formRules = reactive({
  name: [{ required: true, message: '商品名不能为空', trigger: 'blur' }],
  url: [{ required: true, message: 'url不能为空', trigger: 'blur' }],
  point: [{ required: true, message: '兑换积分不能为空', trigger: 'blur' }],
  userId: [{ required: true, message: '用户id不能为空', trigger: 'blur' }],
  contactName: [{ required: true, message: '联系人姓名不能为空', trigger: 'blur' }],
  contactPhone: [{ required: true, message: '联系电话不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await RedeemApi.getRedeem(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as RedeemVO
    if (formType.value === 'create') {
      await RedeemApi.createRedeem(data)
      message.success(t('common.createSuccess'))
    } else {
      await RedeemApi.updateRedeem(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    url: undefined,
    point: undefined,
    userId: undefined,
    contactName: undefined,
    contactAddress: undefined,
    contactPhone: undefined,
    status: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>